<?php
namespace Avaliacao\Entities;

use Avaliacao\Repositories;

class Respavaliacao extends Base\Respavaliacao
{
    public function gravaRespostasAvaliacao(
        $nrorg,
        $nrexecavaliacao,
        $nrresposta,
        $txrespavaliacao=null
    ){
        try {
            $obj = new self();
            $obj->setNrexecavaliacao($nrexecavaliacao);
            $obj->setNrresposta($nrresposta);
            $obj->setTxrespavaliacao($txrespavaliacao);
            $obj->setIdativo('S');
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);
            $obj->persist();

            return true;

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function retornaQuantVotosPorResposta($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $tema_analise, $nrresposta) {
        $result = \Avaliacao\Repositories\Respavaliacao::query_consultaQuantVotosResposta($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $tema_analise, $nrresposta);
        return $result;
    }

    public static function excluiRespAvaliacao($nrorg, $nrexecavaliacao){
        try {
            \Avaliacao\Repositories\Respavaliacao::query_excluiRespAvaliacao($nrorg, $nrexecavaliacao);
            return true;
        } catch(\Exception $e) {
            return false;
        }
    }

    public function atualizaRespostaAvaliacao(
        $nrorg,
        $nrexecavaliacao,
        $nrresposta,
        $txrespavaliacao
    ) {
        $lista_resposta = Respavaliacao::getObjectsByWhere(
            'NRORG = ? AND NREXECAVALIACAO = ?',
            array(
                $nrorg,
                $nrexecavaliacao,
            )
        );

        /** @var $resposta Respavaliacao */
        foreach ($lista_resposta as $resposta) {
            $resposta->setNrresposta($nrresposta);
            $resposta->setTxrespavaliacao($txrespavaliacao);
            $resposta->persist();
        }

        return true;
    }

    public static function excluiRespostasAvaliacao($nrorg, $nravaliacao) {
        try {
            $sql = "DELETE FROM RESPAVALIACAO
                    WHERE NRORG = {$nrorg}
                      AND NREXECAVALIACAO IN
                       (SELECT NREXECAVALIACAO
                          FROM EXECAVALIACAO
                         WHERE NRAVALIACAO = {$nravaliacao})";
            \Setforms2\Shared\Connection::getInstance()->execute($sql);
            return true;
        } catch(\Exception $e) {
            return false;
        }
    }
}